/** Copyright (C) 2017 by Bundesanstalt für Gewässerkunde
 * Software engineering by
 *  Björnsen Beratende Ingenieure GmbH
 *  Dr. Schumacher Ingenieurbüro für Wasser und Umwelt
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */
package org.dive4elements.river.artifacts.sinfo.tkhstate;

import java.util.Collection;

import org.dive4elements.artifactdatabase.data.DefaultStateData;
import org.dive4elements.artifactdatabase.data.StateData;
import org.dive4elements.river.artifacts.D4EArtifact;
import org.dive4elements.river.artifacts.WINFOArtifact;

/**
 * Ugly wrapper around WINfoArtifact in order to a) not to break serialization of WInfoArtifact b) be able to copy data
 * into it.
 *
 * @author Gernot Belger
 */
public final class WinfoArtifactWrapper extends WINFOArtifact {

    private static final long serialVersionUID = 1L;

    public WinfoArtifactWrapper(final D4EArtifact dataSource) {
        final Collection<StateData> allData = dataSource.getAllData();
        for (final StateData stateData : allData) {

            final DefaultStateData clonedData = new DefaultStateData();
            clonedData.set(stateData);

            addData(clonedData.getName(), clonedData);
        }

        addStringData("calculation_mode", "calc.surface.curve");
    }
}